﻿Imports System.Runtime.InteropServices
Imports System.Text

Public Class Form1

    Private Const NI_MAXHOST As Integer = 1025

    <StructLayout(LayoutKind.Sequential)> Public Structure eztcp_info
        <MarshalAs(UnmanagedType.ByValArray, sizeconst:=6)> Public mac_address() As Byte
        <MarshalAs(UnmanagedType.ByValArray, sizeconst:=1025)> Public hostname() As Byte
        <MarshalAs(UnmanagedType.ByValArray, sizeconst:=65)> Public comment() As Byte
        <MarshalAs(UnmanagedType.I4)> Public env_status As Integer
        <MarshalAs(UnmanagedType.ByValArray, sizeconst:=32)> Public product_name() As Byte
        <MarshalAs(UnmanagedType.I4)> Public search_method As Integer
        <MarshalAs(UnmanagedType.I4)> Public search_port As Integer
    End Structure

    Public l_eztcp_info As New eztcp_info

    <DllImport("user32.dll", SetLastError:=True, CharSet:=CharSet.Ansi)> _
    Public Shared Function GetWindowText(hwnd As IntPtr, <MarshalAs(UnmanagedType.LPStr)> lpString As System.Text.StringBuilder, cch As Integer) As Integer
    End Function

    <DllImport("ezManagerLib.dll", SetLastError:=True)> _
    Public Shared Sub Start_Library()
    End Sub

    <DllImport("ezManagerLib.dll", SetLastError:=True)> _
    Public Shared Sub End_Library()
    End Sub
    <DllImport("ezManagerLib.dll", CallingConvention:=CallingConvention.StdCall, SetLastError:=True)> _
    Public Shared Function EzTCP_Search(udp_port_number As Integer, ByRef err As Long) As Integer
    End Function

    <DllImport("ezManagerLib.dll", CallingConvention:=CallingConvention.StdCall, SetLastError:=True)> _
    Public Shared Function get_eztcp_count() As Integer
    End Function

    <DllImport("ezManagerLib.dll", CallingConvention:=CallingConvention.StdCall, SetLastError:=True)> _
    Public Shared Function get_eztcp_info_by_index(index As Integer, ByRef out_eztcp_info As eztcp_info) As Integer
    End Function

    <DllImport("ezManagerLib.dll", CallingConvention:=CallingConvention.StdCall, SetLastError:=True, CharSet:=CharSet.Ansi)> _
    Public Shared Function get_ip4_local_address(ByRef mac_address As Byte, <MarshalAs(UnmanagedType.LPStr)> out_address As StringBuilder) As Integer
    End Function

    <DllImport("ezManagerLib.dll", CallingConvention:=CallingConvention.StdCall, SetLastError:=True, CharSet:=CharSet.Ansi)> _
    Public Shared Function set_ip4_local_address(ByRef mac_address As Byte, <MarshalAs(UnmanagedType.LPStr)> ip4_local_address As StringBuilder) As Integer
    End Function

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Dim err As Long
        Dim ret As Integer

        ret = EzTCP_Search(50005, err)

        Dim cnt As Integer
        cnt = get_eztcp_count()        

        If cnt > 0 Then
            ret = get_eztcp_info_by_index(0, l_eztcp_info)

            Dim addr As StringBuilder = New StringBuilder(256)

            ret = get_ip4_local_address(l_eztcp_info.mac_address(0), addr)

            MsgBox(ret)

            MsgBox(addr.ToString())

            addr.Clear()

            addr.Append("10.1.0.100")

            MsgBox(addr.ToString())

            ret = set_ip4_local_address(l_eztcp_info.mac_address(0), addr)

            MsgBox(ret)

            addr.Clear()

            ret = get_ip4_local_address(l_eztcp_info.mac_address(0), addr)

            MsgBox(ret)

            MsgBox(addr.ToString())
        End If

    End Sub

    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        Start_Library()
    End Sub

    Protected Overrides Sub Finalize()
        End_Library()

        MyBase.Finalize()
    End Sub
End Class
